"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.templateEnd = exports.templateBegin = exports.globalName = void 0;
exports.globalName = '__LOAD_EXTERNAL_DEPENDENCIES_WEBPACK_PLUGIN__';
const countTimeString = `load all dependencies by ${exports.globalName} spend`;
/** 模板头部，只在第一个入口文件中插入 */
exports.templateBegin = (deps) => `
window.${exports.globalName} = (function() {
  const loadedUrlSet = new Set();
  const deps = ${JSON.stringify(deps)};
  return new Promise((allResolve, allReject) => {
    const append = (index) => {
      if (index >= deps.length) {
        allResolve();
        return Promise.resolve();
      };
      const url = deps[index].url;
      if (url.endsWith('.css')) {
        const linkNode = document.createElement('link');
        linkNode.setAttribute('rel', 'stylesheet');
        linkNode.href = url;
        document.head.appendChild(linkNode);
        return append(index + 1);
      };
      if (loadedUrlSet.has(url)) {
        return append(index + 1);
      };
      const scriptNode = document.createElement('script');
      scriptNode.setAttribute('rel', 'preload');
      scriptNode.src = url;
      document.head.appendChild(scriptNode);
      const varName = deps[index].varName;
      const version = deps[index].version;
      return new Promise((resolve, reject) => {
        scriptNode.onload = () => {
          if (window[varName] && version) {
            window[varName + version.replace(/[^0-9a-z_$]/g, '')] = window[varName]
          }
          resolve();
          loadedUrlSet.add(url);
          append(index + 1);
        };
        scriptNode.onerror = () => {
          reject();
          allReject();
        };
      });
    };
    console.time('${countTimeString}');
    append(0);
  });
})().then(() => {console.timeEnd('${countTimeString}')});
window.${exports.globalName}.documentCurrentScript = document.currentScript;
`;
/** 在所有入口文件中插入 */
exports.templateEnd = [
    `;${exports.globalName}.then(() => {
`,
    `
});`,
];
